
#include "KVStore.h"
#include "config.h"
#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include<pthread.h>
long int getSetId(char * key){
	return strlen(key)%NO_OF_SETS;
}

kvcache_data** init_cache(){
	printf("Initializing Cache Memory\n");
	kvcache_data **t = (kvcache_data **)malloc(NO_OF_SETS * sizeof(kvcache_data *));
	for (int i = 0; i < NO_OF_SETS; ++i){
		t[i] = (kvcache_data *)malloc( sizeof(kvcache_data)*NO_OF_CACHE_ENTRIES);
		for(int j=0;j<NO_OF_CACHE_ENTRIES;j++){
			t[i][j].chance=-1;
		}
		}
	
	return t;
}
int* rep_line_per_set(){
	int* x=(int *)calloc(sizeof(int),NO_OF_CACHE_ENTRIES);
	for(int i=0;i<NO_OF_CACHE_ENTRIES;i++){
		x[i]=0;
	}
	return x;
}

pthread_mutex_t * lock_initialize(){
		printf("Initializing Cache Locks\n");
		pthread_mutex_t *x=(pthread_mutex_t*)calloc(sizeof(pthread_mutex_t),NO_OF_CACHE_ENTRIES);
		for(int i=0;i<NO_OF_CACHE_ENTRIES;i++){
			if(pthread_mutex_init(&x[i],NULL)!=0){
				printf("failed\n");
			}
		}
		return x;
}
int getInCache(kvcache_data** t,int* repl,pthread_mutex_t* cache_lock, char *key,char *value){
	int ln=getSetId(key)-1;
	pthread_mutex_lock(&cache_lock[ln]);
	for(int i=0;i<NO_OF_CACHE_ENTRIES;i++){
		if(t[ln][i].chance!=-1)
		{
			if(!strcmp(t[ln][i].key,key)){
				t[ln][i].chance=1;
				strcpy(value,t[ln][i].value);
				pthread_mutex_unlock(&cache_lock[ln]);
				return 1;
			}	
		}
		else{
			break;
		}
	}

	int temp=repl[ln];
	while(t[ln][temp].chance==1){
		t[ln][temp].chance=0;
		repl[ln]=(repl[ln]+1)%NO_OF_CACHE_ENTRIES;
		temp=repl[ln];
	}
	if(!restoreFromFile(key,value)){
		pthread_mutex_unlock(&cache_lock[ln]);
		return 0;
	}
	else{
		strcpy(t[ln][temp].key,key);
		strcpy(t[ln][temp].value,value);
		repl[ln]=(repl[ln]+1)%NO_OF_CACHE_ENTRIES;
		t[ln][temp].chance=0;
		pthread_mutex_unlock(&cache_lock[ln]);
		return 1;
		
	}

	
	


}
int postInCache(kvcache_data** t,int* repl,pthread_mutex_t* cache_lock, char *key,char *value){
	int ln=getSetId(key)-1;
	pthread_mutex_lock(&cache_lock[ln]);
	for(int i=0;i<NO_OF_CACHE_ENTRIES;i++){
		if(t[ln][i].chance!=-1)
		{
			if(!strcmp(t[ln][i].key,key)){
				t[ln][i].chance=1;
				strcpy(t[ln][i].value,value);
				pthread_mutex_unlock(&cache_lock[ln]);
				return 1;
			}	
		}
		else{
			break;
		}
	}
	int temp=repl[ln];
	while(t[ln][temp].chance==1){
		t[ln][temp].chance=0;
		repl[ln]=(repl[ln]+1)%NO_OF_CACHE_ENTRIES;
		temp=repl[ln];
	}
	//printf("%d\n",temp);
	strcpy(t[ln][temp].key,key);
	strcpy(t[ln][temp].value,value);
	repl[ln]=(repl[ln]+1)%NO_OF_CACHE_ENTRIES;
	t[ln][temp].chance=0;
		
	if(dumpToFile(&t[ln][temp])){
		pthread_mutex_unlock(&cache_lock[ln]);
		return 1;
	}
	else{
		return 0;
		pthread_mutex_unlock(&cache_lock[ln]);
	}
	pthread_mutex_unlock(&cache_lock[ln]);
	return 1;

}
int delInCache(kvcache_data** t,int* repl,pthread_mutex_t* cache_lock, char *key){
	int ln=getSetId(key)-1;
	pthread_mutex_lock(&cache_lock[ln]);
	for(int i=0;i<NO_OF_CACHE_ENTRIES;i++){
		if(t[ln][i].chance!=-1)
		{
			if(!strcmp(t[ln][i].key,key)){
				t[ln][i].chance=0;
				strcpy(t[ln][i].key,"");
				strcpy(t[ln][i].value,"");
				
			}	
		}
		else{
			break;
		}
	}

	if(deleteFromFile(key)){
		pthread_mutex_unlock(&cache_lock[ln]);
		return 1;
	}
	else{
		pthread_mutex_unlock(&cache_lock[ln]);
		return 0;
	}
}
/*
int main(){
kvcache_data **t= init_cache();
int *repl=rep_line_per_set();

char value[1232];
printf("%d\n",postInCache(t,repl,"x","xenon"));
printf("%d\n",postInCache(t,repl,"y","yak"));
printf("%d\n",getInCache(t,repl,"y",value));
printf("%d\n",delInCache(t,repl,"y"));
printf("%d\n",getInCache(t,repl,"z",value));	


for(int i =0;i<10;i++){
	printf("%d %d %s %s\n",i,t[1-1][i].chance,t[1-1][i].key,t[1-1	][i].value);
}
}
*/
