jobs_queue *tpool_work_get(tpool_t *tm)
{
    jobs_queue *work;

    if (tm == NULL)
        return NULL;

    work = tm->head;
    if (work == NULL)
        return NULL;

    if (work->next == NULL) {
        tm->head = NULL;
        tm->tail  = NULL;
    } else {
        tm->head = work->next;
    }

    return work;
}

void process_worker(jobs_queue *job,tpool_t* tm){
    //printf("executing job\n");
    char resp[300000];
    if(!strcmp(job->messagetype,"putreq")){
        if(postInCache(tm->t,tm->repl,tm->cache_lock, job->key,job->value)){
            toXML(resp,"","","resp","Success");
        }
        else{
                toXML(resp,"","","resp","IOError");
        
        }
    }
    else if(!strcmp(job->messagetype,"getreq")){
        if(getInCache(tm->t,tm->repl,tm->cache_lock ,job->key,job->value)){
                toXML(resp,job->key,job->value,"resp","");  
            }
        else{
            toXML(resp,"","","resp","Does not exist");
        }
    }
    else if(!strcmp(job->messagetype,"delreq")){
        if(delInCache(tm->t,tm->repl,tm->cache_lock, job->key)){
            toXML(resp,"","","resp","Success");
        }
        else{
            toXML(resp,"","","resp","Does not exist");
        
        }
    }
    //printf("%s\n",resp);
    write(job->fd,resp,strlen(resp));
    printf("Request fulfilled of client no. %d\n",job->fd );
} 
void *worker(void *arg){
    jobs_queue *x=NULL;
    tpool_t *tm= (tpool_t*) arg ;
    while(1){
    pthread_mutex_lock(&tm->work_mutex);
    //printf("thread:locked by %ld\n",pthread_self());
    while(tm->head==NULL){
        //printf("unlocked and waiting by %ld\n",pthread_self());
        pthread_cond_wait(&tm->work_cond,&tm->work_mutex);
        
    }
    //printf("job came acquired by %ld\n",pthread_self());

    tm->working_cnt++;
    x=tpool_work_get(tm);
    //printf("%d\n",x->fd);
    pthread_mutex_unlock(&tm->work_mutex);
    //printf("unlocked by %ld\n",pthread_self());
    process_worker(x,tm);
    free(x);

    pthread_mutex_lock(&tm->work_mutex);
    tm->working_cnt--;
    if(tm->working_cnt==0 && tm->head==NULL){
        pthread_cond_signal(&tm->working_cond);
    }
    pthread_mutex_unlock(&tm->work_mutex);


    }
    tm->thread_cnt--;
    pthread_cond_signal(&(tm->working_cond));
    pthread_mutex_unlock(&(tm->work_mutex));
    return NULL;
} 
tpool_t *tpool_create(size_t num,kvcache_data** t,int* repl,pthread_mutex_t* cache_lock,pthread_mutex_t q_lock)
{
    printf("Creating threadpool\n");
    tpool_t   *tm;
    pthread_t  thread;
    size_t     i;

    if (num == 0)
        num = 2;

    tm = calloc(1, sizeof(*tm));
    tm->thread_cnt = num;
    tm->t=t;
    tm->repl=repl;
    tm->cache_lock=cache_lock;
    tm->head=NULL;
    tm->tail=NULL;
    //pthread_mutex_init(&(tm->work_mutex), NULL);
    tm->work_mutex=q_lock;
    pthread_cond_init(&(tm->work_cond), NULL);
    pthread_cond_init(&(tm->working_cond), NULL);

    

    for (i=0; i<num; i++) {
        pthread_create(&thread, NULL, worker, tm);
        pthread_detach(thread);
    }

    return tm;
}

